diff --git a/django/contrib/gis/db/backends/postgis/creation.py b/django/contrib/gis/db/backends/postgis/creation.py
index bad22be..9d422a5 100644
--- a/django/contrib/gis/db/backends/postgis/creation.py
+++ b/django/contrib/gis/db/backends/postgis/creation.py
@@ -38,12 +38,17 @@ class PostGISCreation(DatabaseCreation):
                                   style.SQL_FIELD(qn(f.column)) +
                                   style.SQL_KEYWORD(' SET NOT NULL') + ';')
 
-
             if f.spatial_index:
                 # Spatial indexes created the same way for both Geometry and
                 # Geography columns
+                # PostGIS 2.0 does not support GIST_GEOMETRY_OPS
                 if f.geography:
                     index_opts = ''
+                elif self.connection.ops.spatial_version >= (2, 0):
+                    if f.dim > 2:
+                        index_opts = ' ' + style.SQL_KEYWORD('gist_geometry_ops_nd')
+                    else:
+                        index_opts = ''
                 else:
                     index_opts = ' ' + style.SQL_KEYWORD(self.geom_index_opts)
                 output.append(style.SQL_KEYWORD('CREATE INDEX ') +
diff --git a/docs/ref/contrib/gis/install.txt b/docs/ref/contrib/gis/install.txt
index 72bd72a..7d237ee 100644
--- a/docs/ref/contrib/gis/install.txt
+++ b/docs/ref/contrib/gis/install.txt
@@ -83,7 +83,7 @@ Program                   Description                           Required
 `PROJ.4`_                 Cartographic Projections library      Yes (PostgreSQL and SQLite only)  4.7, 4.6, 4.5, 4.4
 :ref:`GDAL <ref-gdal>`    Geospatial Data Abstraction Library   No (but, required for SQLite)     1.9, 1.8, 1.7, 1.6, 1.5
 :ref:`GeoIP <ref-geoip>`  IP-based geolocation library          No                                1.4
-`PostGIS`__               Spatial extensions for PostgreSQL     Yes (PostgreSQL only)             1.5, 1.4, 1.3
+`PostGIS`__               Spatial extensions for PostgreSQL     Yes (PostgreSQL only)             2.0, 1.5, 1.4, 1.3
 `SpatiaLite`__            Spatial extensions for SQLite         Yes (SQLite only)                 3.0, 2.4, 2.3
 ========================  ====================================  ================================  ==========================
 
@@ -239,9 +239,9 @@ installed prior to building PostGIS.
 
 First download the source archive, and extract::
 
-    $ wget http://postgis.refractions.net/download/postgis-1.5.2.tar.gz
-    $ tar xzf postgis-1.5.2.tar.gz
-    $ cd postgis-1.5.2
+    $ wget http://postgis.refractions.net/download/postgis-2.0.1.tar.gz
+    $ tar xzf postgis-2.0.1.tar.gz
+    $ cd postgis-2.0.1
 
 Next, configure, make and install PostGIS::
 
@@ -255,8 +255,9 @@ Finally, make and install::
 
 .. note::
 
-    GeoDjango does not automatically create a spatial database.  Please
-    consult the section on :ref:`spatialdb_template` for more information.
+    If you are running a version of PostgreSQL earlier than 9.1: GeoDjango does
+    not automatically create a spatial database.  Please consult the section on
+    :ref:`spatialdb_template` for more information.
 
 __ http://postgis.refractions.net/
 
@@ -502,11 +503,25 @@ to build and install::
 Post-installation
 =================
 
+Creating a spatial database with PostGIS 2.0 and PostgreSQL 9.1
+------------------------------------------------
+
+PostGIS 2 includes an extension for Postgres 9.1 that can be used to enable
+spatial functionality. 
+
+    $ createdb  <db name>
+    $ psql <db name>
+    > CREATE EXTENSION postgis;
+    > CREATE EXTENSION postgis_topology;
+
 .. _spatialdb_template:
 
 Creating a spatial database template for PostGIS
 ------------------------------------------------
 
+If you have an earlier version of PostGIS or PostgreSQL, you will need to create
+a spatial database.
+
 Creating a spatial database with PostGIS is different than normal because
 additional SQL must be loaded to enable spatial functionality.  Because of
 the steps in this process, it's better to create a database template that
diff --git a/docs/releases/1.5.txt b/docs/releases/1.5.txt
index 3a9b2d8..19353f6 100644
--- a/docs/releases/1.5.txt
+++ b/docs/releases/1.5.txt
@@ -252,6 +252,8 @@ on the form.
 Miscellaneous
 ~~~~~~~~~~~~~
 
+* GeoDjango added support for PostGIS 2.0
+
 * GeoDjango dropped support for GDAL < 1.5
 
 * :func:`~django.utils.http.int_to_base36` properly raises a :exc:`TypeError`